<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>2.2.5.RELEASE</version>
        <relativePath /> <!-- lookup parent from repository -->
    </parent>
    <groupId>com.emirates.parentproject</groupId>
    <artifactId>flightStatusService</artifactId>
    <version>1.0.0</version>
    <packaging>jar</packaging>
    <name>${project.artifactId}</name>
    <description>Flight Status Service</description>

    <properties>
        <sonar.projectKey>mudassir.shahzad111_flightstatus-service</sonar.projectKey>
        <sonar.organization>mudassir-shahzad111</sonar.organization>
        <sonar.host.url>https://sonarcloud.io</sonar.host.url>
        <sonar.moduleKey>
            ${artifactId}
        </sonar.moduleKey>
        <sonar.core.codeCoveragePlugin>jacoco</sonar.core.codeCoveragePlugin>
        <sonar.dynamicAnalysis>reuseReports</sonar.dynamicAnalysis>
        <sonar.coverage.jacoco.xmlReportPaths>${project.basedir/../target/site/jacoco-aggregate/jacoco.xml
        </sonar.coverage.jacoco.xmlReportPaths>
        <sonar-jacoco-plugin.version>2.3</sonar-jacoco-plugin.version>

        <jacoco.haltOnFailure>true</jacoco.haltOnFailure>

        <start-class>com.emirates.parentproject.flightstatus.Application</start-class>
        <junit5.version>5.2.0</junit5.version>
        <platform.version>1.2.0</platform.version>
        <surefire.version>2.22.0</surefire.version>
        <mockwebserver.version>4.7.2</mockwebserver.version>
        <okhttp3.version>4.9.1</okhttp3.version>
        <maven.compiler.source>1.8</maven.compiler.source>
        <maven.compiler.target>1.8</maven.compiler.target>

        <sonar.exclusions>
            **/*Application*.*,
            **/*Filter*.*,
            **/*FilterConfig*.*,
            **/*Exception*.*,
            **/*Bean*.*,
            **/*Response*.*,
            **/*Request*.*,
            **/*ErrorHandler*.*,
            **/*Domain*.*,
            **/*DAO*.*,
            **/*DTO*.*,
            **/*Constants*.*,
            **/*Translator.*,
            **/*Config.*,
            **/entities/**/*,
            **/configuration/**/*,
            **/apis/**/*,
            **/gateway/**/*,
            **/models/**/*.*,
            **/deprecated/**/*,
            **/security/**/*,
            **/exception/handler/*
        </sonar.exclusions>
        <sonar.test.exclusions>
            **/test/*, **/test/**
        </sonar.test.exclusions>
        <sonar.coverage.exclusions>
            **/*Application*.*,
            **/*Filter*.*,
            **/*FilterConfig*.*,
            **/*Exception*.*,
            **/*Bean*.*,
            **/*Response*.*,
            **/*Request*.*,
            **/*Domain*.*,
            **/*ErrorHandler*.*,
            **/*DAO*.*,
            **/*DTO*.*,
            **/*Constants*.*,
            **/*Translator.*,
            **/*Config.*,
            **/entities/**/*,
            **/configuration/**/*,
            **/apis/**/*,
            **/gateway/**/*,
            **/models/**/*.*,
            **/deprecated/**/*,
            **/security/**/*,
            **/exception/handler/*
        </sonar.coverage.exclusions>
    </properties>

    <dependencies>

        <!-- Jackson dependencies -->
        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-annotations</artifactId>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-core</artifactId>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.core</groupId>
            <artifactId>jackson-databind</artifactId>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.datatype</groupId>
            <artifactId>jackson-datatype-jsr310</artifactId>
        </dependency>

        <dependency>
            <groupId>io.projectreactor</groupId>
            <artifactId>reactor-test</artifactId>
            <scope>test</scope>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.datatype</groupId>
            <artifactId>jackson-datatype-jdk8</artifactId>
        </dependency>

        <!-- This plugin is used by latest versions of sonarqube -->
        <dependency>
            <groupId>org.codehaus.sonar-plugins.java</groupId>
            <artifactId>sonar-jacoco-plugin</artifactId>
            <version>${sonar-jacoco-plugin.version}</version>
        </dependency>

        <dependency>
            <groupId>com.fasterxml.jackson.module</groupId>
            <artifactId>jackson-module-parameter-names</artifactId>
        </dependency>

        <dependency>
            <groupId>javax.validation</groupId>
            <artifactId>validation-api</artifactId>
        </dependency>

        <!-- Jupiter dependencies -->
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter-api</artifactId>
            <version>${junit5.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter-params</artifactId>
            <version>${junit5.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.junit.jupiter</groupId>
            <artifactId>junit-jupiter-engine</artifactId>
            <version>${junit5.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.junit.vintage</groupId>
            <artifactId>junit-vintage-engine</artifactId>
            <version>${junit5.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.junit.platform</groupId>
            <artifactId>junit-platform-launcher</artifactId>
            <version>${platform.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.junit.platform</groupId>
            <artifactId>junit-platform-runner</artifactId>
            <version>${platform.version}</version>
            <scope>test</scope>
        </dependency>

        <!-- Spring Boot dependencies -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-webflux</artifactId>
        </dependency>

        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-data-couchbase-reactive</artifactId>
        </dependency>

        <!-- Spring boot actuator to expose metrics endpoint -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-actuator</artifactId>
        </dependency>
        <dependency>
            <groupId>io.micrometer</groupId>
            <artifactId>micrometer-core</artifactId>
        </dependency>
        <dependency>
            <groupId>io.micrometer</groupId>
            <artifactId>micrometer-registry-prometheus</artifactId>
        </dependency>

        <!-- Test dependencies -->
        <dependency>
            <groupId>org.springframework.boot</groupId>
            <artifactId>spring-boot-starter-test</artifactId>
            <scope>test</scope>
            <exclusions>
                <exclusion>
                    <groupId>com.vaadin.external.google</groupId>
                    <artifactId>android-json</artifactId>
                </exclusion>
                <exclusion>
                    <groupId>junit</groupId>
                    <artifactId>junit</artifactId>
                </exclusion>
            </exclusions>
        </dependency>

        <dependency>
            <groupId>com.squareup.okhttp3</groupId>
            <artifactId>okhttp</artifactId>
            <version>${mockwebserver.version}</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>com.squareup.okhttp3</groupId>
            <artifactId>mockwebserver</artifactId>
            <version>${mockwebserver.version}</version>
            <scope>test</scope>
        </dependency>

        <!--<dependency>-->
        <!--<groupId>org.mockito</groupId>-->
        <!--<artifactId>mockito-core</artifactId>-->
        <!--<version>2.19.0</version>-->
        <!--<scope>test</scope>-->
        <!--</dependency>-->
        <dependency>
            <groupId>org.glassfish</groupId>
            <artifactId>javax.el</artifactId>
            <version>3.0.1-b10</version>
        </dependency>

        <!-- https://mvnrepository.com/artifact/io.projectreactor/reactor-test -->
        <dependency>
            <groupId>io.projectreactor</groupId>
            <artifactId>reactor-test</artifactId>
            <version>3.1.8.RELEASE</version>
            <scope>test</scope>
        </dependency>

        <!-- Spring REST Docs dependencies -->
        <dependency>
            <groupId>org.springframework.restdocs</groupId>
            <artifactId>spring-restdocs-core</artifactId>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.springframework.restdocs</groupId>
            <artifactId>spring-restdocs-webtestclient</artifactId>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-surefire-plugin</artifactId>
            <version>2.22.0</version>
        </dependency>
        <dependency>
            <groupId>org.springframework.restdocs</groupId>
            <artifactId>spring-restdocs-asciidoctor</artifactId>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>org.projectlombok</groupId>
            <artifactId>lombok</artifactId>
        </dependency>
        <dependency>
            <groupId>org.testng</groupId>
            <artifactId>testng</artifactId>
            <version>RELEASE</version>
            <scope>test</scope>
        </dependency>
        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <scope>test</scope>
        </dependency>

    </dependencies>

    <build>
        <resources>
            <resource>
                <filtering>true</filtering>
                <directory>src/main/resources</directory>
                <includes>
                    <include>**/*.json</include>
                    <include>**/*.xml</include>
                    <include>**/*.properties</include>
                    <include>**/*.yml</include>
                    <include>**/*.jks</include>
                    <include>**/*.yaml</include>
                    <include>**/*.png</include>
                    <include>**/*.html</include>
                    <include>**/*.css</include>
                    <include>**/*.js</include>
                    <include>**/*.map</include>
                </includes>
            </resource>
        </resources>
        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>${surefire.version}</version>
                <dependencies>
                    <dependency>
                        <groupId>org.junit.platform</groupId>
                        <artifactId>junit-platform-surefire-provider</artifactId>
                        <version>${platform.version}</version>
                    </dependency>
                    <dependency>
                        <groupId>org.junit.jupiter</groupId>
                        <artifactId>junit-jupiter-engine</artifactId>
                        <version>${junit5.version}</version>
                    </dependency>
                </dependencies>
            </plugin>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <executions>
                    <execution>
                        <id>prepare-agent</id>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                    <!-- Attached to Maven test phase. This phase also enables sonar cloud
                        to see the reports. -->
                    <execution>
                        <id>report</id>
                        <phase>test</phase>
                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                    <execution>
                        <id>check</id>
                        <goals>
                            <goal>check</goal>
                        </goals>
                        <configuration>
                            <haltOnFailure>${jacoco.haltOnFailure}</haltOnFailure>
                            <rules>
                                <rule>
                                    <excludes>
                                        <exclude>**/*Test.*</exclude>
                                        <exclude>**/*Application*.*</exclude>
                                        <exclude>**/*Config.*</exclude>
                                        <exclude>**/*Bean.*</exclude>
                                        <exclude>**/*Entity.*</exclude>
                                        <exclude>**/*Exception.*</exclude>
                                        <exclude>**/*Refresher.*</exclude>
                                        <exclude>**/*ErrorDetails.*</exclude>
                                        <exclude>**/*exceptionhandler.*</exclude>
                                        <exclude>**/*Filter.*</exclude>
                                        <exclude>**/*Builder.*</exclude>
                                        <exclude>**/*Holder.*</exclude>
                                        <exclude>**/*Bean*.*</exclude>
                                        <exclude>**/*.sh</exclude>
                                        <exclude>**/*.cmd</exclude>
                                        <exclude>**/*.md</exclude>
                                        <exclude>**/*.yml</exclude>
                                        <exclude>me/carbee/entities/**/*</exclude>
                                        <exclude>me/carbee/apis/**/*</exclude>
                                        <exclude>me/carbee/gateway/**/*</exclude>
                                        <exclude>**/models/**/*.*</exclude>
                                        <exclude>**/*deprecated/**/*</exclude>
                                        <exclude>**/*configuration/**/*</exclude>
                                    </excludes>
                                    <element>CLASS</element>
                                </rule>
                            </rules>
                        </configuration>
                    </execution>
                </executions>
                <configuration>
                    <excludes>
                        <exclude>**/*Test.*</exclude>
                        <exclude>**/*Application.*</exclude>
                        <exclude>**/*Config.*</exclude>
                        <exclude>**/*Bean.*</exclude>
                        <exclude>**/*Entity.*</exclude>
                        <exclude>**/*Exception.*</exclude>
                        <exclude>**/*Refresher.*</exclude>
                        <exclude>**/*ErrorDetails.*</exclude>
                        <exclude>**/*exceptionhandler.*</exclude>
                        <exclude>**/*Filter.*</exclude>
                        <exclude>**/*Builder.*</exclude>
                        <exclude>**/*Holder.*</exclude>
                        <exclude>**/*Bean*.*</exclude>
                        <exclude>**/*.sh</exclude>
                        <exclude>**/*.cmd</exclude>
                        <exclude>**/*.md</exclude>
                        <exclude>**/*.yml</exclude>
                        <exclude>me/carbee/entities/**/*</exclude>
                        <exclude>me/carbee/apis/**/*</exclude>
                        <exclude>me/carbee/gateway/**/*</exclude>
                        <exclude>**/models/**/*.*</exclude>
                        <exclude>**/*deprecated/**/*</exclude>
                        <exclude>**/*configuration/**/*</exclude>
                    </excludes>
                </configuration>
            </plugin>
        </plugins>
    </build>

    <profiles>
        <profile>
            <id>dev</id>
            <properties>
                <spring.profiles.active>dev</spring.profiles.active>
            </properties>
        </profile>
        <profile>
            <id>test</id>
            <properties>
                <spring.profiles.active>test</spring.profiles.active>
            </properties>
        </profile>
        <profile>
            <id>qa</id>
            <properties>
                <spring.profiles.active>qa</spring.profiles.active>
            </properties>
        </profile>
        <profile>
            <id>prod</id>
            <properties>
                <spring.profiles.active>prod</spring.profiles.active>
            </properties>
        </profile>
    </profiles>

</project>
